%define anolis_release 1
%bcond_with ecore

Name:          dbus-c++
Version:       0.9.0
Release: %{anolis_release}%{dist}
Summary:       Native C++ bindings for D-Bus

License:       LGPLv2+
URL:           http://sourceforge.net/projects/dbus-cplusplus/
Source0:       http://downloads.sourceforge.net/dbus-cplusplus/lib%{name}-%{version}.tar.gz

Patch1: dbus-c++-gcc4.7.patch
Patch2: dbus-c++-linkfix.patch
# Fix collision between macro bind_property in dbus-c++/interface.h and method
# bind_property in glibmm/binding.h
Patch3: dbus-c++-macro_collision.patch
# Remove broken classes for multithreading support
# https://sourceforge.net/p/dbus-cplusplus/patches/18/
Patch4: dbus-c++-threading.patch
# https://sourceforge.net/p/dbus-cplusplus/patches/19/
Patch5: dbus-c++-writechar.patch
# Fix template/operator issues
# https://github.com/pkgw/dbus-cplusplus/commit/a0b9ef3b469ca23c6a3229d8abb967cbbddcee38
Patch6: dbus-c++-template-operators.patch

BuildRequires:  gcc
BuildRequires:  gcc-c++
BuildRequires: dbus-devel
BuildRequires: glib2-devel
BuildRequires: gtkmm24-devel
BuildRequires: autoconf automake libtool
BuildRequires: expat-devel
%if %{with ecore}
BuildRequires: ecore-devel
%endif
BuildRequires: make

%description
dbus-c++ attempts to provide a C++ API for D-Bus.
Subpackages are provided with mainloop integration.

%if %{with ecore}
%package       ecore
Summary:       Ecore library for %{name}
Requires:      %{name} = %{version}-%{release}
%description   ecore
This package contains the ecore mainloop library for %{name}
%endif

%package       glib
Summary:       GLib library for %{name}
Requires:      %{name} = %{version}-%{release}
%description   glib
This package contains the GLib mainloop library for %{name}

%package       devel
Summary:       Development files for %{name}
Requires:      %{name} = %{version}-%{release}
Requires:      pkgconfig
%description   devel
This package contains libraries and header files for
developing applications that use %{name}.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%setup -q -n lib%{name}-%{version}
sed -i 's/\r//' AUTHORS
sed -i 's/libtoolize --force --copy/libtoolize -if --copy/' bootstrap
%patch1 -p1 -b .gcc47
%patch2 -p1 -b .linkfix
%patch3 -p1 -b .collision
%patch4 -p1 -b .threading
%patch5 -p1 -b .writechar
%patch6 -p1 -b .template-operators

%build
autoreconf -vfi
export CPPFLAGS='%{optflags}' CXXFLAGS='--std=gnu++11 %{optflags}'
%configure --disable-static --disable-tests \
%if %{without ecore}
           --disable-ecore
%else
  ;
%endif
%make_build

%install
%make_install
find $RPM_BUILD_ROOT -name '*.la' -print -delete

%generate_compatibility_deps

%files
%license COPYING
%doc AUTHORS
%{_bindir}/dbusxx-introspect
%{_bindir}/dbusxx-xml2cpp
%{_libdir}/libdbus-c++-1.so.0*

%dir %{abidir}
%{abidir}/libdbus-c++-1.dump

%if %{with ecore}
%files ecore
%{_libdir}/libdbus-c++-ecore-1.so.0*
%{abidir}/libdbus-c++-ecore-1.dump
%endif


%files glib
%{_libdir}/libdbus-c++-glib-1.so.0*

%{abidir}/libdbus-c++-glib-1.dump

%files devel
%{_includedir}/*
%{_libdir}/*.so
%{_libdir}/pkgconfig/*

%files doc
%doc ChangeLog AUTHORS INSTALL TODO

%changelog
* Tue Mar 28 2023 Zhongling He <zhonglingh@linux.alibaba.com> - 0.9.0-1
- Init package from upstream
